////////////////////////////////////////////////////////////////
//                                        //
//                   (3D-)              //
//                          3.7                         //
//            (c) 2011, .., ..             //
//                   E-Mail: SGSidorov@mail.ru                //
////////////////////////////////////////////////////////////////

Unit UFaeton;

interface

const
       //   
       plSpace    = $00;  //
       plStenka   = $01;  //
       plIstRight = $02;  // 
       plIstLeft  = $04;  // 
       plIstUp    = $06;  // 
       plIstDown  = $08;  // 
       plIstBl    = $0A;  //  ?
       plIstDl    = $0C;  //   ?
       plOcag     = $10;  // 

       plIst      = $0E;  // 


type  TMatrix  = array of array of array of double;  //
      TBMatrix = array of array of array of byte;    // 
      TVector  = array of double;                    //

var n1     :longint;  //   
    n2     :longint;  //   
    n3     :longint;  //   

var u1     :TMatrix;  // 
    u2     :TMatrix;  // 
    u3     :TMatrix;  // 
    p      :TMatrix;  //
    ro     :TMatrix;  //
    tem    :TMatrix;  //
    divu   :TMatrix;  //
    pp     :TMatrix;  //   
    rotop  :TMatrix;  //  (  )
    Plan   :TBMatrix; //    

    fZagor :boolean;  //  
    dt     :double;   //  

procedure SetMatrix;               //  
procedure ClearIst;                // 
procedure InitIst;                 // 
procedure ResetBounds;             //   
procedure InitVar;                 // 

procedure NewFields;               //   

procedure DivSpeed;                // 
procedure CalcPress;               // 
procedure SaveInFile(Name:string); //   
procedure Gorenie;                 //
procedure ClearPlan(T:byte);       // 

implementation

const
      u0      = 10;          //  
      anu     = 1;           //
      danu    = 1;           //
      danu1   = 1;           //
      h       = 1.0;         //  
      hh      = h*h;         // h  
      r0      = 1/h;         // 1 / 
      r1      = 1/(2*h);     // 1 / 2 
      r2      = r1/4;        //  
      m2      = 0.001;       //
      ap      = m2/hh;       //
//      q0      = 2.5*r0;      //
//      c2      = 100;         //
      gaz     = 50;          //
      qbig    = 10;          //
//      mstep   = 1;           //
      tzvezda = 10;          //
      qlitl   = 170;         //  
      bab     = 1;           //

var
    n1v   :longint;  //    - 1
    n2v   :longint;  //    - 1
    n3v   :longint;  //    - 1
    n1g   :longint;  //    - 2
    n2g   :longint;  //    - 2
    n3g   :longint;  //    - 2
    lg    :TVector;  //
    lv    :TVector;  //
    ld    :TVector;  //


////////////////////////////////////////////////////////////////
//                                      //
////////////////////////////////////////////////////////////////

procedure SetMatrix;  //  
var  R1,R2,R3 :longint;   // 
begin
     R1:=N1+1;  R2:=N2+1;  R3:=N3+1;
     SetLength(u1,   R1,R2,R3);   SetLength(u2,   R1,R2,R3);
     SetLength(u3,   R1,R2,R3);   SetLength(p,    R1,R2,R3);
     SetLength(ro,   R1,R2,R3);   SetLength(tem,  R1,R2,R3);
     SetLength(divu, R1,R2,R3);   SetLength(pp,   R1,R2,R3);
     SetLength(rotop,R1,R2,R3);   SetLength(Plan, R1,R2,R3);
     SetLength(lg,R1);  SetLength(lv,R2);  SetLength(ld,R3);
end;

procedure ClearPlan(T:byte); // 
var  i,j,k :longint;  //  X,Y,Z
begin
     for i:=1 to n1 do for j:=1 to n2 do for k:=1 to n3 do
         if (T=plSpace)or(Plan[i,j,k]=T) then Plan[i,j,k]:=plSpace;
end;

procedure ClearIst; // 
var  i,j,k :longint;  //  X,Y,Z
begin
     for i:=1 to n1 do for j:=1 to n2 do for k:=1 to n3 do
         if (Plan[i,j,k] and plIst)<>0 then
            Plan[i,j,k]:=Plan[i,j,k] and (not plIst);
end;

procedure InitIst; // 
var  i,j,k :longint;  // , 
begin
     //   
     for i:=1 to n1 do for j:=1 to n2 do for k:=1 to n3 do
         if (i=1)or(j=1)or(k=1)or(i=n1)or(j=n2)or(k=n3) then Plan[i,j,k]:=plIstRight;
end;

procedure ResetBounds; //   
var  i,j,k :longint;  // , 
begin
     for i:=1 to n1 do for j:=1 to n2 do for k:=1 to n3 do begin
         if Plan[i,j,k] and plStenka = plStenka then begin     //
            u1[i,j,k]:=0;  u2[i,j,k]:=0;  u3[i,j,k]:=0;
         end;
         if Plan[i,j,k] and plIstRight = plIstRight then begin // 
            u1[i,j,k]:=u0; u2[i,j,k]:=0;  u3[i,j,k]:=0;
            ro[i,j,k]:=1;  tem[i,j,k]:=10;
         end;
         if Plan[i,j,k] and plIstLeft = plIstLeft then begin   // 
            u1[i,j,k]:=-u0; u2[i,j,k]:=0; u3[i,j,k]:=0;
            ro[i,j,k]:=1;   tem[i,j,k]:=10;
         end;
         if Plan[i,j,k] and plIstUp = plIstUp then begin   // 
            u1[i,j,k]:=0; u2[i,j,k]:=-u0; u3[i,j,k]:=0;
            ro[i,j,k]:=1; tem[i,j,k]:=10;
         end;
         if Plan[i,j,k] and plIstDown = plIstDown then begin   // 
            u1[i,j,k]:=0; u2[i,j,k]:=u0; u3[i,j,k]:=0;
            ro[i,j,k]:=1; tem[i,j,k]:=10;
         end;

         if Plan[i,j,k] and plIstBl = plIstBl then begin   // 
            u1[i,j,k]:=0; u2[i,j,k]:=0; u3[i,j,k]:=-u0;
            ro[i,j,k]:=1; tem[i,j,k]:=10;
         end;
         if Plan[i,j,k] and plIstDl = plIstDl then begin   // 
            u1[i,j,k]:=0; u2[i,j,k]:=0; u3[i,j,k]:=u0;
            ro[i,j,k]:=1; tem[i,j,k]:=10;
         end;
         if Plan[i,j,k] and plOcag = plOcag then begin   //
            if fZagor then rotop[i,j,k]:=5;  // 
            fZagor:=false;
         end;
     end;
end;

procedure InitVar; // 
var  i,j,k :longint;  // , 
begin
     n1v:=n1-1; n2v:=n2-1; n3v:=n3-1;
     n1g:=n1-2; n2g:=n2-2; n3g:=n3-1;
     // , 
     for i:=1 to n1 do for j:=1 to n2 do for k:=1 to n3 do begin
         u1[i,j,k]:=0; u2[i,j,k]:=0; u3[i,j,k]:=0;
         p[i,j,k]:=0;  ro[i,j,k]:=1; tem[i,j,k]:=10;
         rotop[i,j,k]:=0;
     end;
     ResetBounds;
     dt:=0.01;
     // 
     lg[2]:=0;  for i:=2 to n1v do lg[i+1]:=ap/(1+2*ap-ap*lg[i]);
     lv[2]:=0;  for j:=2 to n2v do lv[j+1]:=ap/(1+2*ap-ap*lv[j]);
     ld[2]:=0;  for k:=2 to n3v do ld[k+1]:=ap/(1+2*ap-ap*ld[k]);
end;

procedure SaveInFile(Name:string); //   
var  F     :file of double; //
     i,j,k :longint;      //
begin
     AssignFile(F,Name); Rewrite(F);
     for i:=1 to n1 do
         for j:=1 to n2 do
             for k:=1 to n3 do Write(F,u1[i,j,k],u2[i,j,k],u3[i,j,k]);
     CloseFile(F);
end;

////////////////////////////////////////////////////////////////
//                                              //
////////////////////////////////////////////////////////////////

procedure ProtivoProizv2(var U,R:TMatrix;anu:double); // 
var  i,j,k   :longint;  //  X,Y,Z
     s11z1   :double;   //
     s12z2   :double;   //
     s13z3   :double;   //

     Uc      :double;   //  
     Up      :double;   // 
     Ul      :double;   // 
     Uv      :double;   // 
     Un      :double;   // 
     Ub      :double;   //  ?
     Ud      :double;   //  ?

     u11     :double;   //
     u12     :double;   //
     u13     :double;   //
begin
     for i:=2 to n1v do for j:=2 to n2v do for k:=2 to n3v do begin

         Uc:=U[i,j,k];      //
         Up:=U[i+1,j,k];    //
         Ul:=U[i-1,j,k];    //
         Uv:=U[i,j+1,k];    //
         Un:=U[i,j-1,k];    //
         Ub:=U[i,j,k+1];    // ?
         Ud:=U[i,j,k-1];    // ?

         if u1[i,j,k]>0 then u11:=r0*(Uc-Ul) else u11:=r0*(Up-Uc);
         if u2[i,j,k]>0 then u12:=r0*(Uc-Un) else u12:=r0*(Uv-Uc);
         if u3[i,j,k]>0 then u13:=r0*(Uc-Ud) else u13:=r0*(Ub-Uc);

         s11z1:=anu*(Up-2*Uc+Ul)/hh;
         s12z2:=anu*(Uv-2*Uc+Un)/hh;
         s13z3:=anu*(Ub-2*Uc+Ud)/hh;

         R[i,j,k]:=s11z1+s12z2+s13z3-
                   u1[i,j,k]*u11-u2[i,j,k]*u12-u3[i,j,k]*u13;
     end;
end;

procedure Progon(var M,T,MV:TMatrix); // 3D
var  i,j,k :longint;  // , 
     q     :double;   //
begin
     //  
     for j:=2 to n2v do begin
         for k:=2 to n3v do begin
             MV[2,j,k]:=0;
             for i:=2 to n1v do begin     //  ()
                 q:=-ap*M[i-1,j,k]+(1+2*ap)*M[i,j,k]-ap*M[i+1,j,k]+dt*T[i,j,k];
                 MV[i+1,j,k]:=(q/ap+MV[i,j,k])*lg[i+1];
             end;
             for i:=n1 downto 2 do begin  //  ()
                 M[i-1,j,k]:=lg[i]*M[i,j,k]+MV[i,j,k];
             end;
         end;
     end;
     ResetBounds;
     //  
     for i:=2 to n1v do begin
         for k:=2 to n3v do begin
             MV[i,2,k]:=0;
             for j:=2 to n2v do begin     //  ()
                 q:=-ap*M[i,j-1,k]+(1+2*ap)*M[i,j,k]-ap*M[i,j+1,k]+dt*T[i,j,k];
                 MV[i,j+1,k]:=(q/ap+MV[i,j,k])*lv[j+1];
             end;
             for j:=n2 downto 2 do begin  //  ()
                 M[i,j-1,k]:=lv[j]*M[i,j,k]+MV[i,j,k];
             end;
         end;
     end;
     ResetBounds;
     //  
     for i:=2 to n1v do begin
         for j:=2 to n2v do begin
             MV[i,j,2]:=0;
             for k:=2 to n3v do begin     //  () ???
                 q:=-ap*M[i,j,k-1]+(1+2*ap)*M[i,j,k]-ap*M[i,j,k+1]+dt*T[i,j,k];
                 MV[i,j,k+1]:=(q/ap+MV[i,j,k])*ld[k+1];
             end;
             for k:=n3 downto 2 do begin  //  () ???
                 M[i,j,k-1]:=ld[k]*M[i,j,k]+MV[i,j,k];
             end;
         end;
     end;
     ResetBounds;
end;

procedure NewField(var M:TMatrix;anu:double); //  
begin
     ProtivoProizv2(M,pp,anu);  //   "pp"
     Progon(M,pp,divu);         // (divu -  )
end;

procedure NewFields; //   
begin
     NewField(u1,anu);     //  
     NewField(u2,anu);     //  
     NewField(u3,anu);     //  
     NewField(ro,danu);    //
     NewField(tem,danu1);  //
end;

function PrX(var M:TMatrix;i,j,k:longint):double; //  X
begin
     result:=((M[i+1,j+1,k+1]+M[i+1,j-1,k+1]+M[i+1,j+1,k-1]+M[i+1,j-1,k-1])-
              (M[i-1,j+1,k+1]+M[i-1,j-1,k+1]+M[i-1,j+1,k-1]+M[i-1,j-1,k-1]))*r2;
end;

function PrY(var M:TMatrix;i,j,k:longint):double; //  Y
begin
     result:=((M[i+1,j+1,k+1]+M[i-1,j+1,k+1]+M[i-1,j+1,k-1]+M[i+1,j+1,k-1])-
              (M[i+1,j-1,k-1]+M[i-1,j-1,k-1]+M[i-1,j-1,k+1]+M[i+1,j-1,k+1]))*r2;
end;

function PrZ(var M:TMatrix;i,j,k:longint):double; //  Z
begin
     result:=((M[i+1,j+1,k+1]+M[i+1,j-1,k+1]+M[i-1,j-1,k+1]+M[i-1,j+1,k+1])-
              (M[i+1,j-1,k-1]+M[i-1,j-1,k-1]+M[i-1,j+1,k-1]+M[i+1,j+1,k-1]))*r2;
end;

procedure DivSpeed; //   3D
var  i,j,k :longint;  // , 
begin
     for i:=2 to n1v do for j:=2 to n2v do for k:=2 to n3v do
         divu[i,j,k]:=PrX(u1,i,j,k)+PrY(u2,i,j,k)+PrZ(u3,i,j,k);
end;

procedure Flats(var M:TMatrix); //    ( !)
var  i,j,k  :longint;  // , , 
begin
     for i:=2 to n1v do begin
         for j:=2 to n2v do begin
             M[i,j,1]:=M[i,j,2]; M[i,j,n3]:=M[i,j,n3v];
         end;
         for k:=2 to n3v do begin
             M[i,1,k]:=M[i,2,k]; M[i,n2,k]:=M[i,n2v,k];
         end;
     end;
     for j:=2 to n2v do for k:=2 to n3v do begin
         M[1,j,k]:=M[2,j,k]; M[n1,j,k]:=M[n1v,j,k];
     end;
end;

procedure Angles(var M:TMatrix); //   
begin
     M[ 1, 1, 1] := M[  2,  2,  2];
     M[n1, 1, 1] := M[n1v,  2,  2];
     M[n1,n2, 1] := M[n1v,n2v,  2];
     M[ 1,n2, 1] := M[  2,n2v,  2];
     M[ 1, 1,n3] := M[  2,  2,n3v];
     M[n1, 1,n3] := M[n1v,  2,n3v];
     M[n1,n2,n3] := M[n1v,n2v,n3v];
     M[ 1,n2,n3] := M[  2,n2v,n3v];
end;

procedure CalcPress; //  3D
var  i,j,k  :longint;  // , , 
var  p11, p22, p33 :real;
begin
     for i:=2 to n1v do for j:=2 to n2v do for k:=2 to n3v do begin
         ro[i,j,k]:=ro[i,j,k]-ro[i,j,k]*dt*divu[i,j,k];
         p[i,j,k] :=ro[i,j,k]*gaz*tem[i,j,k];
     end;

     //   
     //     ( !)
     Flats(p); Flats(ro); Flats(tem);
     //   
     Angles(u1);    Angles(u2);    Angles(u3);
     Angles(ro);    Angles(tem);   Angles(p);

     for i:=2 to n1v do for j:=2 to n2v do for k:=2 to n3v do begin
         p11:=PrX(p,i,j,k);
         p22:=PrY(p,i,j,k);
         p33:=PrZ(p,i,j,k);
         //  
         u1[i,j,k]:=u1[i,j,k]-dt*p11;
         u2[i,j,k]:=u2[i,j,k]-dt*(p22+bab*tem[i,j,k]);
         u3[i,j,k]:=u3[i,j,k]-dt*p33;
     end;

     ResetBounds;
end;

procedure Gorenie;  //3D 
const temC2 = 50;
var  i,j,k :longint;  // , , 
     fgor  :double;   //
begin
     for i:=2 to n1v do for j:=2 to n2v do for k:=2 to n3v do begin
         if tem[i,j,k]>temC2 then begin
            fgor:=qbig*abs(tem[i,j,k])/exp(tzvezda/abs(tem[i,j,k]));
            rotop[i,j,k]:=rotop[i,j,k]/(1+dt*fgor);
            if(rotop[i,j,k]<=0) then rotop[i,j,k]:=0;
            tem[i,j,k]:=tem[i,j,k]+dt*qlitl*rotop[i,j,k]*fgor;
         end;
     end;
end;

end.
