////////////////////////////////////////////////////////////////
//                   OpenGL ""             //
//                          3.3                         //
//            (c) 2011, .., ..             //
//                   E-Mail: SGSidorov@mail.ru                //
////////////////////////////////////////////////////////////////

unit UOpenGL;

interface

uses Windows, OpenGL;

const
       //  
       msBound   = $01; // 
       msSpeed   = $02; //  
       msPress   = $04; //  
       msTemp    = $08; //  
       msIst     = $10; // 

       m3Prof    = 1; //  
       m3Top     = 2; //  
       m3Face    = 3; //  
       m3D       = 4; // 3D-

       mlA       = 0; //  
       mlX       = 1; //   X
       mlY       = 2; //   Y
       mlZ       = 3; //   Z

var
     ModeShow  :word;            // : msBound, msSpeed, msPress, msTemp
     Mode3D    :word;            // : m3Prof, m3Top, m3Face, m3D
     ModeLayer :word;            // : mlX, mlY, mlZ, mlA

     AngleX   :double = 30;      //   X
     AngleY   :double = -30;      //   Y
     AngleZ   :double = 0;      //   Z

     X0       :longint;         // X  
     Y0       :longint;         // Y  

     fRotate  :boolean = false; // 

     MS       :double = 200;    //

     LrX      :longint; //    X
     LrY      :longint; //    Y
     LrZ      :longint; //    Z

procedure glInit(Wnd:hWND);
procedure glLoadTexture(FileName:String; var Texture:GLuint);
procedure glOnResize(Width,Height:Integer);
procedure glDraw();
procedure glKill(Wnd:hWND);

implementation

uses UFaeton;

procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;
function gluBuild2DMipmaps(Target: GLenum; Components, Width, Height: GLint; Format, atype: GLenum; Data: Pointer): GLint; stdcall; external glu32;
procedure glGenTextures(n: GLsizei; var textures: GLuint); stdcall; external opengl32;
procedure SetDCPixelFormat(DC: hDC); forward;

var  DC       :hDC;                 //  
     RC       :hGLRC;               //  

     X1,X2    :double;              //    X
     Y1,Y2    :double;              //    Y
     Z1,Z2    :double;              //    Z

     H        :double = 2; //5;          // 



//     Texture  :GLuint;              //  
     Angle    :Integer = 0;         //   

{------------------------------------------------------------------}
{   OpenGL                                            }
{------------------------------------------------------------------}

procedure glInit(Wnd: hWND); // OpenGL
const
      // ,    
      mat1_amb : array [0..2] of Single = (0.2, 0.2, 0.2);
      mat1_dif : array [0..2] of Single = (0.8, 0.8, 0.0);
      mat1_spec: array [0..2] of Single = (0.6, 0.6, 0.6);
      mat1_shininess = 10;
      //    
      light_pos  : array [0..3] of glFloat = (100.0, 100.0, 0.0, 1.0);
      light_amb  : array [0..3] of glFloat = (0.6, 0.6, 0.6, 1.0);
      light_dif  : array [0..3] of glFloat = (1.0, 1.0, 1.0, 1.0);
      light_spec : array [0..3] of glFloat = (1.0, 1.0, 1.0, 1.0);
      light_spot_direction : array [0..3] of glFloat = (1.0, 1.0, 1.0, 1.0);
      //  
      fogColor: array [0..3] of GLfloat = (0, 1.0, 0, 1.0);
var   fogMode: GLint;
begin
     //    OpenGL
     DC := GetDC(Wnd);            //     
     SetDCPixelFormat(DC);        //   
     RC := wglCreateContext(DC);  //    
     wglMakeCurrent(DC,RC);       //   
     //     glEnable(GL_COLOR_MATERIAL)
     glMaterialfv(GL_FRONT, GL_AMBIENT,  @mat1_amb);
     glMaterialfv(GL_FRONT, GL_DIFFUSE,  @mat1_dif);
     glMaterialfv(GL_FRONT, GL_SPECULAR, @mat1_spec);
     glMaterialf (GL_FRONT, GL_SHININESS,mat1_shininess);
     //    GL_LIGHT1   glEnable(GL_LIGHTING)
     //    :  glEnable(GL_LIGHT0);
     glLightfv(GL_LIGHT1, GL_POSITION,@light_pos);
     glLightfv(GL_LIGHT1, GL_AMBIENT, @light_amb);    // 
     glLightfv(GL_LIGHT1, GL_DIFFUSE, @light_dif);    // 
     glLightfv(GL_LIGHT1, GL_SPECULAR, @light_spec);
     glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, @light_spot_direction);
     //    GL_LIGHT1
     glEnable(GL_LIGHT1);
     //     glEnable(GL_FOG)
     fogMode := GL_EXP;                     // GL_EXP2, GL_LINEAR
     glFogi(GL_FOG_MODE, fogMode);          //  
     glFogfv(GL_FOG_COLOR, @fogColor);      //  
     glFogf(GL_FOG_DENSITY, 0.002);         //   - 0.2%
     glHint(GL_FOG_HINT, GL_DONT_CARE);     // GL_NICEST, GL_FASTEST.
     glClearColor(1.0, 1.0, 1.0, 1.0);      //    - 
     glClearDepth(1.0);                     //   
     glDepthFunc(GL_LESS);                  //   
     glShadeModel(GL_SMOOTH);               //   
     // glEnable(..) -  , glDisable(..) - 
     glEnable(GL_LIGHTING);                 //  
     //glEnable(GL_FOG);                    //  
     glEnable(GL_DEPTH_TEST);               //   ,  
                                            //    glDepthFunc
     glEnable(GL_NORMALIZE);                //   ( 
                                            //     )
     glEnable(GL_COLOR_MATERIAL);           //     
     glEnable(GL_TEXTURE_2D);               //   
     //glEnable(GL_BLEND);                  //   (. )
                                            //    glEnable(GL_DEPTH_TEST)
     //glLoadTexture('1.bmp', Texture);       //  
end;

{------------------------------------------------------------------}
{                                 }
{------------------------------------------------------------------}

procedure glOnResize(Width, Height: Integer);
//var  k :double;  //  
begin
     if (Height = 0) then Height:=1;    //    0
     glViewport(0, 0, Width, Height);   //   
                                        //   
     //   
    glMatrixMode(GL_PROJECTION);        //   
    glLoadIdentity();                   //   
    //    - 
{
    X1:=-H; //-Width div 2;
    X2:=102*H; // Width div 2;
    Y1:=-H; //-Height div 2;
    Y2:=51*H;  // Height div 2;
    Z1:=-800;
    Z2:= 800;
}
{
    X1:=-2*n1*H;    X2:=2*n1*H;
    Y1:=-2*n2*H;    Y2:=2*n2*H;
    Z1:=-2*n3*H;    Z2:=2*n3*H;
}

    X1:=-MS;    X2:=MS;
    Y1:=-MS*Height/Width;    Y2:=MS*Height/Width;
    Z1:=-MS;    Z2:=MS;


    glOrtho(X1,X2,Y1,Y2,Z1,Z2);

//    k:=Width/Height;
//    glOrtho(-500*k, 500*k, -500, 500, -500, 500);

    //   
    glMatrixMode(GL_MODELVIEW);         //   
    glLoadIdentity();                   //   
end;


{------------------------------------------------------------------}
{     OpenGL                                      }
{------------------------------------------------------------------}

procedure glKill(Wnd: hWND);
begin
     wglMakeCurrent(DC, 0);
     wglDeleteContext(RC);
     ReleaseDC(Wnd, DC);
end;

{------------------------------------------------------------------}
{        DC                  }
{------------------------------------------------------------------}

procedure SetDCPixelFormat(DC: hDC);
var  pfd          :TPixelFormatDescriptor;
     nPixelFormat :Integer;
begin
     FillChar(pfd, SizeOf(pfd), 0);
     with pfd do begin
          nSize      := sizeof(pfd);
          nVersion   := 1;
          dwFlags    := PFD_DRAW_TO_WINDOW or
                        PFD_SUPPORT_OPENGL or
                        PFD_DOUBLEBUFFER;
          iPixelType := PFD_TYPE_RGBA;
          cColorBits := 16;
          cDepthBits := 64;
          iLayerType := PFD_MAIN_PLANE;
     end;
     nPixelFormat := ChoosePixelFormat(DC, @pfd);
     SetPixelFormat(DC, nPixelFormat, @pfd);
end;

{------------------------------------------------------------------}
{   8  24- bmp-                     }
{------------------------------------------------------------------}

procedure glLoadTexture(Filename: String; var Texture: GLuint);
type BitmapHeader = record
       FH :BitmapFileHeader;
       IH :BitmapInfoHeader;
     end;
var  ColorTable: array of TRGBQuad;
     Data: array of Byte;
     RGBData: array of TRGBTriple;
     Bmp: BitmapHeader;
     tmp, i, L: Cardinal;
     F: hFile;
begin
     F := CreateFile(PChar(FileName), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, 0, 0);
     if F = INVALID_HANDLE_VALUE then begin
        MessageBox(0,PChar('File '+ FileName + ' not found'), 'glLoadTexture',0);
        exit;
     end;
     ReadFile(F, Bmp, sizeof(BitmapHeader),tmp, nil );
     L := Bmp.IH.biWidth * Bmp.IH.biHeight;
     SetLength(RGBData, L);
     case Bmp.IH.biBitCount of
       8 :begin
               SetLength(ColorTable, round(exp(Bmp.IH.biBitCount*Ln(2))));
               ReadFile(F, ColorTable[0], SizeOf(TRGBQuad) * round(exp(Bmp.IH.biBitCount*Ln(2))), tmp, nil);
               SetLength(Data, L);
               ReadFile(F, Data[0], SizeOf(Byte) * L, tmp, nil);
               for i := 0 to L - 1 do begin
                   RGBData[L - i - 1].rgbtRed   := ColorTable[Data[i]].rgbBlue;
                   RGBData[L - i - 1].rgbtGreen := ColorTable[Data[i]].rgbGreen;
                   RGBData[L - i - 1].rgbtBlue  := ColorTable[Data[i]].rgbRed;
               end;
          end;
      24 :begin
               SetLength(Data, L * 3);
               ReadFile(F, Data[0], SizeOf(Byte) * L * 3, tmp, nil);
               for i := 0 to L - 1 do begin
                   RGBData[L - i - 1].rgbtRed   := Data[3 * i];
                   RGBData[L - i - 1].rgbtGreen := Data[3 * i + 1];
                   RGBData[L - i - 1].rgbtBlue  := Data[3 * i + 2];
               end;
          end;
     else MessageBox(0, 'Format not support', 'glLoadTexture', 0);
     end; { end case}
     CloseHandle(F);
     //    BMP.pas  Jan Horn
     glGenTextures(1, Texture);
     glBindTexture(GL_TEXTURE_2D, Texture);
     glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);  {Texture blends with object background}
     //  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);  {Texture does NOT blend with object background}
     {

   Select a filtering type. BiLinear filtering produces very good results with little performance impact

   GL_NEAREST               - Basic texture (grainy looking texture)

   GL_LINEAR                - BiLinear filtering

   GL_LINEAR_MIPMAP_NEAREST - Basic mipmapped texture

   GL_LINEAR_MIPMAP_LINEAR  - BiLinear Mipmapped texture

}
     glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR); { only first two can be used }
     glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR); { all of the above can be used }
     gluBuild2DMipmaps(GL_TEXTURE_2D, 3, Bmp.IH.biWidth, Bmp.IH.biHeight, GL_RGB, GL_UNSIGNED_BYTE, RGBData);
     // Use when not wanting mipmaps to be built by openGL
     // glTexImage2D(GL_TEXTURE_2D, 0, 3, Bmp.IH.biWidth, Bmp.IH.biHeight, 0, GL_RGB, GL_UNSIGNED_BYTE, RGBData);
end;


{------------------------------------------------------------------}
{                                      }
{------------------------------------------------------------------}

function Xe(X:longint):double; //   ->  
begin
     result:=(X-(n1/2))*H;
end;

function Ye(Y:longint):double; //   ->  
begin
     result:=(Y-(n2/2))*H;
end;

function Ze(Z:longint):double; //   ->  
begin
     result:=(Z-(n3/2))*H;
end;

procedure glDraw(); //
const  k = 1; //3;  //
//var  Obj :GLUquadricObj;
var  ix,iy,iz :longint;  //  
     Max      :double;   // 
begin
     //     
     glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
     glMatrixMode(GL_MODELVIEW);            //    
     glLoadIdentity;                        //   
{
GL_POINTS -  
GL_LINES -  ( ;  )
GL_LINE_STRIP -  (  lineto)
GL_LINE_LOOP - 
GL_TRIANGLES - 
GL_TRIANGLE_STRIP -   
GL_TRIANGLE_FAN
GL_QUADS - 
GL_QUAD_STRIP -   
GL_POLYGON -  
}

     //  
//     glRotate(-90, 0.0, 1.0, 0.0);
//     glRotate(60, 1.0, 0.0, 0.0);
     //     
//     glRotate(-Angle, 1.0, 1.0, 1.0);

     // 
     Case Mode3D of
       m3Prof: begin
//                 glTranslate(Xe(n1),Ye(n2),Ze(n3));
                 glRotate(0, 1.0, 0.0, 0.0);
                 glRotate(0, 0.0, 1.0, 0.0);
                 glRotate(0, 0.0, 0.0, 1.0);
               end;
       m3Top:  begin
//                 glTranslate(Xe(n1),Ye(n2),Ze(n3));
                 glRotate(90, 1.0, 0.0, 0.0);
                 glRotate(0, 0.0, 1.0, 0.0);
                 glRotate(0, 0.0, 0.0, 1.0);
               end;
       m3Face: begin
//                 glTranslate(Xe(n1),Ye(n2),Ze(n3));
                 glRotate(0, 1.0, 0.0, 0.0);
                 glRotate(90, 0.0, 1.0, 0.0);
                 glRotate(0, 0.0, 0.0, 1.0);
               end;
       m3D:    begin
//                 glTranslate(Xe(n1),Ye(n2),Ze(n3));
                 glRotate(AngleX, 1.0, 0.0, 0.0);
                 glRotate(AngleY, 0.0, 1.0, 0.0);
                 glRotate(AngleZ, 0.0, 0.0, 1.0);
               end;
     end;

//     glRotate(AngleX, Xe(n1), Ye(n2), Ze(n3));
//     glRotate(AngleZ, Xe(n1 div 2), Ye(n2), Ze(n3 div 2));

//     glRotate(AngleX, Xe(n1 div 2), Ye(n2 div 2), Ze(n3 div 2));
//     glRotate(AngleZ, Xe(n1 div 2), Ye(n2 div 2), Ze(n3 div 2));

//     glRotate(AngleX, 1.0, 1.0, 1.0);

//     glRotate(AngleZ, 0.0, 0.0, Ze(Round(n3/2)));

//     glRotate(AngleZ, 0.0, Ze(Round(n2/2)), 0.0);
//     glRotate(AngleX, Ze(Round(n1/2)), 0.0, 0.0);


     // 
     if ModeShow and msBound = msBound then begin
        glBegin(GL_LINES);
          glColor(0.0, 1.0, 0.0, 0.0);
          glVertex3F(Xe( 1),Ye( 1),Ze( 1)); glVertex3F(Xe(n1),Ye( 1),Ze( 1));  // 1- 
          glVertex3F(Xe(n1),Ye( 1),Ze( 1)); glVertex3F(Xe(n1),Ye(n2),Ze( 1));  // 2- 
          glVertex3F(Xe(n1),Ye(n2),Ze( 1)); glVertex3F(Xe( 1),Ye(n2),Ze( 1));  // 3- 
          glVertex3F(Xe( 1),Ye(n2),Ze( 1)); glVertex3F(Xe( 1),Ye( 1),Ze( 1));  // 4- 
          glVertex3F(Xe( 1),Ye( 1),Ze(n3)); glVertex3F(Xe(n1),Ye( 1),Ze(n3));  // 5- 
          glVertex3F(Xe(n1),Ye( 1),Ze(n3)); glVertex3F(Xe(n1),Ye(n2),Ze(n3));  // 6- 
          glVertex3F(Xe(n1),Ye(n2),Ze(n3)); glVertex3F(Xe( 1),Ye(n2),Ze(n3));  // 7- 
          glVertex3F(Xe( 1),Ye(n2),Ze(n3)); glVertex3F(Xe( 1),Ye( 1),Ze(n3));  // 8- 
          glVertex3F(Xe( 1),Ye( 1),Ze( 1)); glVertex3F(Xe( 1),Ye( 1),Ze(n3));  // 9- 
          glVertex3F(Xe(n1),Ye( 1),Ze( 1)); glVertex3F(Xe(n1),Ye( 1),Ze(n3));  // 10- 
          glVertex3F(Xe(n1),Ye(n2),Ze( 1)); glVertex3F(Xe(n1),Ye(n2),Ze(n3));  // 11- 
          glVertex3F(Xe( 1),Ye(n2),Ze( 1)); glVertex3F(Xe( 1),Ye(n2),Ze(n3));  // 12- 
        glEnd;
     end;

     // 
     if ModeShow and msIst = msIst then begin
        glBegin(GL_LINES);
          for ix:=1 to n1 do begin
              for iy:=1 to n2 do begin
                   for iz:=1 to n3 do begin

                       if (ModeLayer=mlX) and (LrX<>ix) then Continue;
                       if (ModeLayer=mlY) and (LrY<>iy) then Continue;
                       if (ModeLayer=mlZ) and (LrZ<>iz) then Continue;

                       if (Plan[ix,iy,iz] and plIst)<>0 then begin
                          // 
                          glColor(1.0, 0.0, 1.0, 0.0);
                          glVertex3F(Xe(ix),Ye(iy),Ze(iz));
                          // 
                          glColor(1.0, 0.0, 0.0, 0.0);
                          glVertex3F(Xe(ix)+u1[ix,iy,iz]*k,
                                     Ye(iy)+u2[ix,iy,iz]*k,
                                     Ze(iz)+u3[ix,iy,iz]*k);
                       end;
                   end;
              end;
          end;
        glEnd;
     end;

     //  
     if ModeShow and msSpeed = msSpeed then begin
        glBegin(GL_LINES);
          for ix:=1 to n1 do begin
              for iy:=1 to n2 do begin
                   for iz:=1 to n3 do begin

                       if (ModeLayer=mlX) and (LrX<>ix) then Continue;
                       if (ModeLayer=mlY) and (LrY<>iy) then Continue;
                       if (ModeLayer=mlZ) and (LrZ<>iz) then Continue;

                       if (Plan[ix,iy,iz] and plIst)<>0 then Continue;

                       // 
                       glColor(0.0, 0.0, 1.0, 0.0);
                       glVertex3F(Xe(ix),Ye(iy),Ze(iz));
                       // 
                       glColor(1.0, 0.0, 0.0, 0.0);
                       glVertex3F(Xe(ix)+u1[ix,iy,iz]*k,
                                  Ye(iy)+u2[ix,iy,iz]*k,
                                  Ze(iz)+u3[ix,iy,iz]*k);
                   end;
              end;
          end;
        glEnd;
     end;

     //  
     if ModeShow and msPress = msPress then begin
        Max:=1000;
        glBegin(GL_POINTS);
          for ix:=1 to n1 do begin
              for iy:=1 to n2 do begin
                   for iz:=1 to n3 do begin

                       if (ModeLayer=mlX) and (LrX<>ix) then Continue;
                       if (ModeLayer=mlY) and (LrY<>iy) then Continue;
                       if (ModeLayer=mlZ) and (LrZ<>iz) then Continue;

                       glColor(0.0+p[ix,iy,iz]/Max, 0.0, 1.0-p[ix,iy,iz]/Max, 0.0);
                       glVertex3F(Xe(ix),Ye(iy),Ze(iz));
                   end;
              end;
          end;
        glEnd;
     end;

     //  
     if ModeShow and msTemp = msTemp then begin
        Max:=20;
        glBegin(GL_POINTS);
          for ix:=1 to n1 do begin
              for iy:=1 to n2 do begin
                   for iz:=1 to n3 do begin

                       if (ModeLayer=mlX) and (LrX<>ix) then Continue;
                       if (ModeLayer=mlY) and (LrY<>iy) then Continue;
                       if (ModeLayer=mlZ) and (LrZ<>iz) then Continue;

                       glColor(0.0+tem[ix,iy,iz]/Max, 0.0, 1.0-tem[ix,iy,iz]/Max, 0.0);
                       glVertex3F(Xe(ix),Ye(iy),Ze(iz));
                   end;
              end;
          end;
        glEnd;
     end;



{
     //     
     glBegin(GL_POLYGON);
       // 1- 
       glColor(0.0, 0.5, 0.0, 0.0);  glVertex3F(300, 0, 0);
       // 2- 
       glColor(0.5, 0.0, 0.0, 0.0);  glVertex3F(-300, 0, 0);
       // 3- 
       glColor(0.0, 0.0, 0.5, 0.0);  glVertex3F(0, -50, 0);

     glEnd;
}

{
     //    
     glBegin(GL_POLYGON);
       glColor(0.0, 0.5, 0.0, 0.0);            //  1- 
       glVertex3F(-50, -sqrt(3)*50, 0);        // 1- 
       glColor(0.5, 0.0, 0.0, 0.0);            //  2- 
       glVertex3F(-100, -sqrt(3)*100, 0);      // 2- 
       glColor(0.0, 0.0, 0.5, 0.0);            //  3- 
       glVertex3F(-125, -sqrt(3)*100, 0);      // 3- 
     glEnd;
}
{
     //     
     //   ,     
     //    
     glRotate(-90, 0.0, 1.0, 0.0);
     glRotate(60, 1.0, 0.0, 0.0);
     //     
     glRotate(-Angle, 0.0, 0.0, 1.0);
     //   
     glColor(1.0, 1.0, 1.0, 0.5);           //   
     glBlendFunc(GL_SRC_ALPHA,GL_ONE);      //    ,
                                            //    
                                            //    glEnable(GL_BLEND)
     glBindTexture(GL_TEXTURE_2D, Texture); //    Texture
     Obj:=gluNewQuadric;
     gluQuadricTexture(Obj, GL_TRUE);       //     
                                            //  
     gluSphere(Obj, 100, 25, 25);           //    R = 100,  - 2525
     gluDeleteQuadric(Obj);                 //  
}
//     Angle := (Angle + 5) mod 360;

     //     
     SwapBuffers(DC);
end;


initialization
              ModeLayer:=mlA;
              LrX:=15; //n1 div 2;
              LrY:=15; //n2 div 2;
              LrZ:=15; //n3 div 2;
end.

